<template>
  <no-ssr>
    <div class="kd-chart" :style="{width}">
      <Icon v-if="lockP5Drawing" class="p5-lock" type="md-lock" />
      <nuxt-p5 :id="domId"
               :width="width"
               :height="height"
               @size="sizeAction" v-on="script">
      </nuxt-p5>
    </div>
  </no-ssr>
</template>

<script>
  import { script, actions, emits, events, functions, baseConfig } from '../../helpers/p5';
  import NuxtP5 from "./NuxtP5";

  const p5Events = {
    ...events,
    _draw(sketch) {
      if (!this.lockP5Drawing) {
        this.sketch = sketch;
        this.drawBackground(sketch);
        this.drawCoordinateSystem(sketch);
        if (this.drawCandleStick) {
          this.drawDataPointCandleStick(sketch);
        }
        if (this.drawCurve.length > 0) {
          this.drawDataPointCurve(sketch);
        }
        this.drawCrossHair(sketch);
      }
    },
  };

  const p5Functions = {
    ...functions,
    drawDataPointCandleStick(sketch) {
      const leftBottom = this.canvas.coordinate.leftBottom;

      this.canvas.show.points.forEach((point) => {
        const data = this.data[point.key];
        const dataIndex = this.dataKeys.indexOf(point.key);

        // max price - min price
        const maxDailyPrice = data['dailyMaxPrice'];
        const minDailyPrice = data['dailyMinPrice'];
        const maxPricePoint = this.dataToPoint(dataIndex, maxDailyPrice);
        const minPricePoint = this.dataToPoint(dataIndex, minDailyPrice);
        const minPricePointInCoordinate = this.inCoordinateSystem(minPricePoint);
        if (!minPricePointInCoordinate) {
          minPricePoint.y = leftBottom.y;
        }
        sketch.stroke(data['candleStickColor']);
        sketch.line(maxPricePoint.x, maxPricePoint.y, minPricePoint.x, minPricePoint.y);

        // opening price - closing price
        const openingPricePoint = this.dataToPoint(dataIndex, data['openingPrice']);
        const openingPricePointY = openingPricePoint.y;
        const closingPricePointY = point.y['closingPrice'];
        const difference = openingPricePointY - closingPricePointY;



        // let rectHeight = point.y['closingPrice'] - openingPricePoint.y;
        // rectHeight = (openingPricePoint.y < leftBottom.y)
        //   ? rectHeight
        //   : leftBottom.y - point.y['closingPrice'];
        sketch.fill(data['candleStickColor']);
        sketch.noStroke();
        sketch.rect(point.x - this.canvas.xUnit/2, point.y['closingPrice'], this.canvas.xUnit, difference);
      });
    },
  };

  export default {
    name: 'StockKdChart',
    mixins: [baseConfig],
    components: { NuxtP5 },
    props: {
      drawCandleStick: { type: Boolean, default: true },
    },
    data() {
      return {
        domId: `kd-chart-${(new Date()).getTime().toString()}`,
        script: script(this),
        canvas: {
          coordinate: {
            step: 0.01,
            longMarkStep: 5,
            longMark: 10,
            shortMarkStep: 1,
            shortMark: 5
          },
        },
        dataFields: [
          { dataField: 'closingPrice', label: 'Close', color: '#ff6666' },
          { dataField: 'avgPrice1', label: '1 AVG', color: '#1a7cde' },
          { dataField: 'avgPrice5', label: '5 AVG', color: '#19de99' },
          { dataField: 'avgPrice10', label: '10 AVG', color: '#dea14d' },
          { dataField: 'avgPrice20', label: '20 AVG', color: '#ff6666' },
          { dataField: 'avgPrice60', label: '60 AVG', color: '#ad61de' },
          { dataField: 'avgPrice120', label: '120 AVG', color: '#b6d05d' },
          { dataField: 'avgPrice240', label: '240 AVG', color: '#b4895e' },
        ],
      };
    },
    computed: {},
    watch: {
      drawCandleStick() {
        this.setFieldToShow();
      },
      drawCurve() {
        this.setFieldToShow();
      },
    },
    methods: {
      ...actions,
      ...emits,
      ...p5Events,
      ...p5Functions,
      setFieldToShow() {
        this.fieldToShow = [...this.drawCurve];
        let closingPriceIsExist = this.fieldToShow.includes('closingPrice');
        if (this.drawCandleStick && closingPriceIsExist) {
          // ignore
        } else if (this.drawCandleStick && !closingPriceIsExist) {
          this.fieldToShow.splice(0, 0, 'closingPrice');
        } else if (!this.drawCandleStick && closingPriceIsExist) {
          this.fieldToShow.splice(0, 1);
          console.log(this.fieldToShow);
        } else if (!this.drawCandleStick && !closingPriceIsExist) {
          // impossible
        }
      }
    },
    mounted() {
      this.setFieldToShow();
    },
  }
</script>

<style lang="scss" scoped>
  .kd-chart {

  }
</style>
